From 4ab73756eb73f10534c482b457057cf83c738918 Mon Sep 17 00:00:00 2001
From: Daniel Pfeifer <daniel@pfeifer-mail.de>
Date: Mon, 25 Mar 2013 11:23:14 +0100
Subject: [PATCH] add some code and TODOs

---
 A/CMakeLists.txt           | 11 +++++++++--
 A/main.cpp                 |  6 ++++++
 B/CMakeLists.txt           |  6 +++---
 B/include/b/hello.hpp      | 11 +++++++++++
 B/include/b/hello_impl.hpp | 11 +++++++++++
 C/CMakeLists.txt           |  6 +++---
 C/include/c/hello.hpp      | 11 +++++++++++
 D/CMakeLists.txt           |  6 +++---
 D/include/d/hello.hpp      | 11 +++++++++++
 9 files changed, 68 insertions(+), 11 deletions(-)
 create mode 100644 A/main.cpp
 create mode 100644 B/include/b/hello.hpp
 create mode 100644 B/include/b/hello_impl.hpp
 create mode 100644 C/include/c/hello.hpp
 create mode 100644 D/include/d/hello.hpp

diff --git a/A/CMakeLists.txt b/A/CMakeLists.txt
index f5a079b..eb5ffe1 100644
--- a/A/CMakeLists.txt
+++ b/A/CMakeLists.txt
@@ -1,4 +1,11 @@
 
-add_library(A STATIC ../dummy.cpp)
+# TODO: get rid of this
+include_directories(
+  ../B/include
+  ../C/include
+  ../D/include
+  )
 
-target_link_libraries(A B)
+add_executable(A main.cpp)
+
+# TODO: A depends on B
diff --git a/A/main.cpp b/A/main.cpp
new file mode 100644
index 0000000..c7911e5
--- /dev/null
+++ b/A/main.cpp
@@ -0,0 +1,6 @@
+#include <b/hello.hpp>
+
+int main(int argc, char *argv[])
+  {
+  b::hello();
+  }
diff --git a/B/CMakeLists.txt b/B/CMakeLists.txt
index 42cd90a..b1ed6c6 100644
--- a/B/CMakeLists.txt
+++ b/B/CMakeLists.txt
@@ -1,4 +1,4 @@
 
-add_library(B STATIC ../dummy.cpp)
-
-target_link_libraries(B C)
+# TODO: create a target B
+# TODO: users of B need "./include/b"
+# TODO: B depends on C
diff --git a/B/include/b/hello.hpp b/B/include/b/hello.hpp
new file mode 100644
index 0000000..9f4d14f
--- /dev/null
+++ b/B/include/b/hello.hpp
@@ -0,0 +1,11 @@
+#include <c/hello.hpp>
+
+namespace b
+{
+
+inline void hello()
+  {
+  c::hello();
+  }
+
+} //namespace b
diff --git a/B/include/b/hello_impl.hpp b/B/include/b/hello_impl.hpp
new file mode 100644
index 0000000..39d4ad5
--- /dev/null
+++ b/B/include/b/hello_impl.hpp
@@ -0,0 +1,11 @@
+#include <iostream>
+
+namespace b
+{
+
+inline void hello_impl()
+  {
+  std::cout << "hello" << std::endl;
+  }
+
+} //namespace b
diff --git a/C/CMakeLists.txt b/C/CMakeLists.txt
index ed36a35..39a3367 100644
--- a/C/CMakeLists.txt
+++ b/C/CMakeLists.txt
@@ -1,4 +1,4 @@
 
-add_library(C STATIC ../dummy.cpp)
-
-target_link_libraries(C D)
+# TODO: create a target C
+# TODO: users of C need "./include/c"
+# TODO: C depends on D
diff --git a/C/include/c/hello.hpp b/C/include/c/hello.hpp
new file mode 100644
index 0000000..d950a1f
--- /dev/null
+++ b/C/include/c/hello.hpp
@@ -0,0 +1,11 @@
+#include <d/hello.hpp>
+
+namespace c
+{
+
+inline void hello()
+  {
+  d::hello();
+  }
+
+} //namespace c
diff --git a/D/CMakeLists.txt b/D/CMakeLists.txt
index 3bf2e9a..fd85d0f 100644
--- a/D/CMakeLists.txt
+++ b/D/CMakeLists.txt
@@ -1,4 +1,4 @@
 
-add_library(D STATIC ../dummy.cpp)
-
-target_link_libraries(D B)
+# TODO: create a target D
+# TODO: users of D need "./include/d"
+# TODO: D depends on B
diff --git a/D/include/d/hello.hpp b/D/include/d/hello.hpp
new file mode 100644
index 0000000..dc75558
--- /dev/null
+++ b/D/include/d/hello.hpp
@@ -0,0 +1,11 @@
+#include <b/hello_impl.hpp>
+
+namespace d
+{
+
+inline void hello()
+  {
+  b::hello_impl();
+  }
+
+} //namespace d
-- 
1.8.0.msysgit.0

